﻿using Hotline.Share.Dtos;
using Hotline.Share.Dtos.FlowEngine;
using Hotline.Share.Dtos.FlowEngine.Definition;

namespace Hotline.Application.FlowEngine
{
    public interface IWorkflowApplication
    {
        /// <summary>
        /// 开始流程
        /// </summary>
        Task StartWorkflowAsync(StartWorkflowDto dto, string externalId, CancellationToken cancellationToken);

        /// <summary>
        /// 流转至下一节点（节点办理）
        /// </summary>
        Task NextAsync(NextWorkflowDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 撤回至任意节点
        /// </summary>
        Task RecallAsync(RecallDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 跳转至任意节点
        /// </summary>
        Task JumpAsync(RecallDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 重办
        /// </summary>
        Task RedoAsync(RecallDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 查询流程开始节点的下一节点配置
        /// </summary>
        Task<DefinedStepDto> GetStartOptionsAsync(string moduleCode, CancellationToken cancellationToken);

        /// <summary>
        /// 查询节点配置可选参数
        /// </summary>
        Task<IReadOnlyList<Kv>> GetNextStepOptionsAsync(StepDefineBasic stepDefine, CancellationToken cancellationToken);
    }
}
